//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Mask.hpp>
#include <Dialogs.hpp>
#include "LMDBaseDialog.hpp"
#include "LMDContainerComponent.hpp"
#include "LMDCustomComponent.hpp"
#include "LMDDirDlg.hpp"
#include "LMDBaseEdit.hpp"
#include "LMDCustomBevelPanel.hpp"
#include "LMDCustomControl.hpp"
#include "LMDCustomEdit.hpp"
#include "LMDCustomMaskEdit.hpp"
#include "LMDCustomPanel.hpp"
#include "LMDMaskEdit.hpp"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TSpeedButton *FLDataDirButton;
    TEdit *FLDirEdit;
    TLabel *Label1;
    TMemo *SearchStringMemo;
    TLabel *Label2;
    TButton *CreateDBButton;
    TPanel *Panel1;
    TButton *SaveDBButton;
    TSpeedButton *DBSearchFileButton;
    TEdit *DBSearchFileEdit;
    TProgressBar *ScanningProgressBar;
    TLabel *CurrentValueLabel;
    TRadioButton *DecSearchRadioButton;
    TLabel *Label3;
    TRadioButton *HexSearchRadioButton;
    TButton *DBSearchButton;
    TPanel *Panel2;
    TEdit *ConvertNameEdit;
    TSpeedButton *CRCGenerateButton;
    TEdit *ConvertDecResultEdit;
    TLabel *Label5;
    TLMDDirDlg *DirectoryDialog;
    TOpenDialog *FileDialog;
    TSaveDialog *SaveDialog;
    TEdit *DecCRCEdit;
    TEdit *HexCRCEdit;
    TEdit *ConvertHexResultEdit;
    TLabel *Label6;
    TLabel *Label7;
    TEdit *ConvertHashDecEdit;
    TEdit *ConvertHashHexEdit;
    TButton *SaveDBTextButton;
    TMemo *ResultMemo;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall CreateDBButtonClick(TObject *Sender);
    void __fastcall DBSearchButtonClick(TObject *Sender);
    void __fastcall CRCGenerateButtonClick(TObject *Sender);
    void __fastcall FLDataDirButtonClick(TObject *Sender);
    void __fastcall DBSearchFileButtonClick(TObject *Sender);
    void __fastcall ConvertNameEditKeyPress(TObject *Sender, char &Key);
    void __fastcall SaveDBButtonClick(TObject *Sender);
    void __fastcall SaveDBTextButtonClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
struct THashLookupEntry {
    unsigned int crc_value;
    unsigned int hash_value;
    int crc_name_length;
    char crc_name[255];
    int from_file_length;
    char from_file[2048];
};

TFileStream *temp_db_file; // temporary file in apps directory for db creation
TStringList *file_list;    // store list of ini's & models to scan
//---------------------------------------------------------------------------
#endif
